import java.io.*;
import java.util.*;

public class Humain {
    
   protected static Random loto = new Random(Calendar.getInstance().getTimeInMillis());
    protected int age;
    protected int poids;
    protected String nom;
    protected int esperanceVie;

    Humain(String nom) {
	this.nom = nom;
	age = 0;
	poids = 3;
	setEsperanceVie();
    }

    Humain(int age, int poids, String nom) {
	this.age = age;
	this.poids = poids;
	this.nom = nom;
	setEsperanceVie();
    }

    void setNom(String nom) {
	this.nom = nom;
    }

    void setAge(int age) {
	if (age < 0) age = 0;
	this.age = age;
    }

    void setPoids(int poids) {
	if (poids < 3) poids = 3;
	this.poids = poids;
    }

    int getAge() {
	return age;
    }
    
    int getPoids() {	
	return poids;
    }

    String getNom() {
	return nom;
    }

    protected void setEsperanceVie() {
	esperanceVie = 70;
    }

    public void vieillir() {
	age++;
    }

    public void grossir(int p) {
	poids += p;
    }

    public boolean isDead() {
	if (age > esperanceVie) {
	    return true;
	}
	if ((age > 20) && (poids < 20)) return true;
	
	return false;
    }

    public void print() {
	System.out.println(nom+" : "+age+" ans, "+poids+" kg, mourra à "+esperanceVie+" ans");
    }
}
