import java.util.*;
import java.io.*;

class Population {

    ArrayList<Humain> pop;

    Population() {
	pop = new ArrayList<Humain>();
    }

    public void vider() {
	pop.clear();
    }

    public Humain getHumain(int index) {
	return pop.get(index);
    }

    public void addHumain(Humain h) {
	pop.add(h);
    }

    public void removeHumain(Humain h) {
	pop.remove(h);
    }

    public void removeHumain(int index) {
	pop.remove(index);
    }

    public int taille() {
	return pop.size();
    }

    public void vieillir() {

	Iterator<Humain> it = pop.iterator();
	Humain h;

	while (it.hasNext()) {
	    h = it.next();
	    h.vieillir();
	    if (h.isDead() == true) {
		System.out.print("  :-( mort de :");
		h.print();
		it.remove();
	    }
	}
    }

    public void print() {

	for(Humain h : pop) {
	    h.print();
	}
    }
}
