import java.io.*;
import java.util.*;

class TP1 {

    public static void main(String[] args) {

	int i,j;
	int taillePop;
	int nbTour;
	Population pop = null;
	Homme h = null;
	Femme f = null;
	Random loto = null;
	int fertilite;
	int nbRencontre;
	int index1,index2;
	Humain h1,h2;
	Humain bebe;

	if (args.length != 2) {
	  
	    System.err.println("utilisation : java Exo taille_pop_initiale nb_tour_jeu");
	    System.exit(1);
	}

	taillePop = Integer.parseInt(args[0]);
	if ((taillePop < 0) || (taillePop > 100)) taillePop = 100;
	nbTour = Integer.parseInt(args[1]);
	if ((nbTour < 0) || (nbTour > 10000)) nbTour = 50;

	pop = new Population();
	loto = new Random(taillePop+nbTour);

	for(i=0;i<taillePop/2;i++) {

	    h = new Homme(20,70,"homme"+(i+1),80);
	    pop.addHumain(h);
	    fertilite = loto.nextInt(101);
	    f = new Femme(20,55,"femme"+(i+1), fertilite);
	    pop.addHumain(f);
	}

	// le jeu

	for(i=0;i<nbTour;i++) {

	    System.out.println("tour "+i+":");
	    if (pop.taille() == 0) {
		System.out.println("tout le monde est mort. Arret du jeu");
		System.exit(0);
	    }
	    if (pop.taille() >= 2) {
		nbRencontre = loto.nextInt(pop.taille()/2);	
	    }
	    else {
		nbRencontre = 0;
	    }	

	    for(j=0;j<nbRencontre;j++) {

		index1 = loto.nextInt(pop.taille());
		index2 = loto.nextInt(pop.taille());

		h1 = pop.getHumain(index1);
		h2 = pop.getHumain(index2);

		bebe = null;
		if (h1 instanceof Homme) {
		    if (h2 instanceof Femme) {
			h = (Homme)h1;
			f = (Femme)h2;
			bebe = h.rencontre(f);
			/* Rq : si les deux méthodes de rencontre sont correctement écrites, on peut
			   égalemenet écrire bebe = f.rencontre(h);
			 */
		    }		    
		}
		else if (h1 instanceof Femme) {
		    if (h2 instanceof Homme) {
			h = (Homme)h2;
			f = (Femme)h1;
			bebe = f.rencontre(h);
			/* Rq : si les deux méthodes de rencontre sont correctement écrites, on peut
			   égalemenet écrire bebe = h.rencontre(f);
			 */
		    }		    
		}

		if (bebe != null) {
		    pop.addHumain(bebe);
		    System.out.print(":-) naissance de : ");
		    bebe.print();
		}
	    }

	    pop.vieillir();
	}
	System.out.println("population finale : " + pop.taille());
    }
}
