public class Femme extends Humain {

	private int fertilite;

	Femme(String nom) {
		super(nom);
		fertilite = 0;
	}

	int getFertilite() {
		return fertilite;
	}


	Femme(int age, int poids, String nom, int fertilite) {
		super(age,poids,nom);
		this.fertilite = fertilite;
	}

	public void vieillir() {
		super.vieillir();
		if (age == 15) {
			fertilite = loto.nextInt(101);
		}
		if (age <= 20) poids = 3+(int)(2.6*age);
		else if (age >= 50) poids += (age % 2);
	}

	// ajout d'un paramètre boolean afin d'éviter de grossir (cf. solution TP1 pour la régulation des naissances)
	public Humain rencontre (Homme h, boolean doGrowth) {

		Humain bebe = null;
		int chance;
		int sexe;

		if ((age > 15) && (age < 50) && (h.getAge() > 15) && (poids < 150) && (h.getPoids() < 150)) {

			chance = loto.nextInt(101);

			if (chance < fertilite) {

				sexe = loto.nextInt(101);

				if (sexe < 50) {
					bebe = new Homme("garcon"+nom+"-"+h.getNom());
				}
				else {
					bebe = new Femme("fille"+nom+"-"+h.getNom());
				}

				if (doGrowth) {
					grossir(10);
					h.grossir(loto.nextInt(21));
				}
			}
		}
		return bebe;
	}

	protected void setEsperanceVie() {
		super.setEsperanceVie();
		// moyenne de 55 et 95 = 75, donc 5 de plus que la base
		esperanceVie += 5;
		// tirage aléatoire de +/- 20
		esperanceVie += loto.nextInt(41) - 20;
	}

	public boolean isFemme() {
		return true;
	}
}
