public class Homme extends Humain {

	int batifolage;

	Homme(String nom) {
		super(nom);
		batifolage = 0;
	}

	Homme(int age, int poids, String nom, int batifolage) {
		super(age,poids,nom);
		this.batifolage = batifolage;
	}

	public void vieillir() {
		super.vieillir();
		if (age <= 20) poids = 3+(int)(3.6*age);
		else if (age >= 50) poids += (age % 2);

		if (age >= 60) {
			batifolage = 50 + loto.nextInt(50);
		}
		else if (age >= 30) {
			batifolage = 20 + loto.nextInt(30);
		}
		else if (age >= 15) {
			batifolage = 70 + loto.nextInt(30);
		}
	}

	// ajout d'un paramètre boolean afin d'éviter de grossir (cf. solution TP1 pour la régulation des naissances)
	public Humain rencontre (Femme f, boolean doGrowth) {

		Humain bebe = null;
		int chance;
		int sexe;

		chance = loto.nextInt(101);
		if (chance <= batifolage) return null;

		if ((age > 15) && (f.getAge() > 15) && (f.getAge() < 50) && (poids < 150) && (f.getPoids() < 150)) {

			chance = loto.nextInt(101);

			if (chance < f.getFertilite()) {

				sexe = loto.nextInt(101);

				if (sexe < 50) {
					bebe = new Homme("garcon"+nom+"-"+f.getNom());
				}
				else {
					bebe = new Femme("fille"+nom+"-"+f.getNom());
				}
				if (doGrowth) {
					f.grossir(10);
					grossir(loto.nextInt(21) - 10);
				}
			}
		}
		return bebe;
	}

	protected void setEsperanceVie() {
		super.setEsperanceVie();
		// moyenne de 50 et 80 = 65, donc 5 de moins que la base
		esperanceVie -= 5;
		// tirage aléatoire de +/- 15
		esperanceVie += loto.nextInt(31) - 15;
	}

	public boolean isHomme() {
		return true;
	}
}
