import java.util.*;

class Population {

	private ArrayList<Humain> pop;

	Population() {
		pop = new ArrayList<Humain>();
	}

	public ArrayList<Humain> getPop() {
		return pop;
	}

	public void vider() {
		pop.clear();
	}

	public void addPopulation(Population p) {
		pop.addAll(p.pop);
	}

	public Humain getHumain(int index) {
		return pop.get(index);
	}

	public void addHumain(Humain h) {
		pop.add(h);
	}

	public Humain removeHumain(Humain h) {

		boolean ok = pop.remove(h);
		if (ok) return h;
		return null;
	}

	public Humain removeHumain(int index) {
		return pop.remove(index);
	}

	public int taille() {
		return pop.size();
	}

	public void vieillir() {

		Iterator<Humain> it = pop.iterator();
		Humain h;

		while (it.hasNext()) {
			h = it.next();
			h.vieillir();
			if (h.isDead() == true) {
				System.out.print("  :-( mort de :");
				h.print();
				it.remove();
			}
		}
	}

	public void print() {

		for(Humain h : pop) {
			h.print();
		}
	}
}
